-- Additional lights made by AR162b for BeamNG.Drive

local M = {}


local lightsPDState = 0
local blinkPDTimerThreshold = 0.4
local blinkPDTimerThresholdHalf = 0
local blinkPDTimer = 0
local blinkPDTimerShort = 0
local blinkPDTimerMode = 0
local blinkshorttime = 0.07
local BlinkSignalTimerShort = 0
local BlinkSignalShortTime = 0.1

local blinkPDModeA = 0
local blinkPDModeB = 1
local blinkPDTimer = 0
local blinkPDPulseLeft = 0
local blinkPDPulseRight = 0
local blinkPDPulseShortLeft = 0
local blinkPDPulseShortRight = 0

local spinning = 0

local function onInit()
	electrics.values['PD_R'] = 0
	electrics.values['PD_L'] = 0

	electrics.values['PD_short_R'] = 0
	electrics.values['PD_short_L'] = 0

	electrics.values['spinleft'] = 0

end

local function reset()
	onInit()
end


local function generateBlinkPDTimer(dt)

    blinkPDTimerThresholdHalf = (blinkPDTimerThreshold / 2)

    blinkPDTimer = blinkPDTimer + (dt)

    if blinkPDTimer > blinkPDTimerThreshold then
        blinkPDTimer = blinkPDTimer - blinkPDTimerThreshold
	blinkPDPulseLeft = 0
	blinkPDPulseRight = 1
	else
    if blinkPDTimer > blinkPDTimerThresholdHalf then
	blinkPDPulseLeft = 1
	blinkPDPulseRight = 0
	end
    end
end

local function generateBlinkPDTimerMode(dt)

    blinkPDTimerMode = blinkPDTimerMode + (dt)

    if blinkPDTimerMode > 7 then
        blinkPDTimerMode = blinkPDTimerMode - 7
	blinkPDModeA = 0
	blinkPDModeB = 1
	else
    if blinkPDTimerMode > 5 then
	blinkPDModeA = 1
	blinkPDModeB = 0
	end
    end
end

local function generateBlinkPDTimerShort(dt)

    blinkPDTimerShort = blinkPDTimerShort + (dt)

    if blinkPDTimerShort > (8*blinkshorttime) then
	blinkPDTimerShort = 0
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 1

    else
    if blinkPDTimerShort > (7*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (6*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 1

    else
    if blinkPDTimerShort > (5*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (4*blinkshorttime) then
	blinkPDPulseShortLeft = 1
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (3*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (2*blinkshorttime) then
	blinkPDPulseShortLeft = 1
	blinkPDPulseShortRight = 0

    else
    if blinkPDTimerShort > (1*blinkshorttime) then
	blinkPDPulseShortLeft = 0
	blinkPDPulseShortRight = 0

    end
    end
    end
    end
    end
    end
    end
    end
end

local function generateSpinning(dt)

    		if spinning > 359 then
        		spinning = 0
		else
			spinning = spinning + (((dt * 100) % 360) * electrics.values['lightbar'])
		end
    	
end



local function updateGFX(dt)
    local vals = M.values
    generateBlinkPDTimer(dt)
    generateBlinkPDTimerShort(dt)	
    generateBlinkPDTimerMode(dt)
    generateSpinning(dt)
	

    	electrics.values['PD_R'] = (electrics.values['lightbar']  * ((blinkPDPulseRight * blinkPDModeB) + (blinkPDPulseLeft * blinkPDModeA)))
    	electrics.values['PD_L'] = (electrics.values['lightbar']  * blinkPDPulseLeft)
    	electrics.values['PD_short_R'] = (electrics.values['lightbar']  * blinkPDPulseShortRight)
    	electrics.values['PD_short_L'] = (electrics.values['lightbar']  * blinkPDPulseShortLeft)
    	electrics.values['spinleft'] = (360 - spinning)
end

 


-- public interface
M.Reset       = Reset
M.onInit	= onInit
M.updateGFX   = updateGFX

return M